package helpers

import "time"

const (
	dateTimeFormat = "2006-01-02 15:04:05"
	yearFormat     = "2006"
	monthFormat    = "01"
	dateFormat     = "02"
	dayFormat      = "2"
)

func ParseDateTime(dateTime string) (time.Time, error) {
	return time.Parse(dateTimeFormat, dateTime)
}

func FormatDateStr(date time.Time) string {
	return date.Format(dayFormat) + " " + getMonthStr(date.Format(monthFormat)) + " " + date.Format(yearFormat)
}

func FormatDateForm(date time.Time) string {
	return date.Format(yearFormat) + "-" + date.Format(monthFormat) + "-" + date.Format(dateFormat)
}

func getMonthStr(month string) string {
	switch month {
	case "01":
		return "января"
	case "02":
		return "февраля"
	case "03":
		return "марта"
	case "04":
		return "апреля"
	case "05":
		return "мая"
	case "06":
		return "июня"
	case "07":
		return "июля"
	case "08":
		return "августа"
	case "09":
		return "сентября"
	case "10":
		return "октября"
	case "11":
		return "ноября"
	case "12":
		return "декабря"
	default:
		return ""
	}
}
